﻿@using Jb.Framework.Common.Forms
@using Jb.Framework.Common.Forms.Validation
@using System.Linq;
@using Jumbula.Common.Helper

@model Jb.Framework.Common.Forms.JbAddress
@{
    var countries = new List<SelectListItem>();
    var states = new List<SelectListItem>();
    var Isdisabled = false;
}
@{
    bool required = Model.IsRequired || Model.Validations.Any(x => x.Type == ElementValidationType.Required);
    var textBoxHtmlAttr = new Dictionary<string, object>();
    var textBoxHtmlAttrState = new Dictionary<string, object>();
    var dropDownHtmlAttrCountry = new Dictionary<string, object>();
    var dropDownHtmlAttrState = new Dictionary<string, object>();

    textBoxHtmlAttr.Add("class", "form-control");
    textBoxHtmlAttrState.Add("class", "form-control");
    dropDownHtmlAttrCountry.Add("class", "form-control");
    dropDownHtmlAttrState.Add("class", "form-control");
    if (Model.CurrentMode != AccessMode.Design)
    {
        if (required || Model.Validations.Any(x => x.Type != ElementValidationType.None))
        {
            textBoxHtmlAttr.Add("data-val", "true");
            textBoxHtmlAttrState.Add("data-val", "true");
            dropDownHtmlAttrCountry.Add("data-val", "true");
            dropDownHtmlAttrState.Add("data-val", "true");
        }
        if (required)
        {
            textBoxHtmlAttr.Add("data-val-Required", "Field is required");
            textBoxHtmlAttrState.Add("data-val-Required", "Field is required");
            dropDownHtmlAttrCountry.Add("data-val-Required", "Field is required");
            dropDownHtmlAttrState.Add("data-val-Required", "Field is required");
        }
        if (Model.CurrentMode == AccessMode.ReadOnly)
        {
            textBoxHtmlAttr.Add("ReadOnly", true);
            textBoxHtmlAttrState.Add("ReadOnly", true);
        }

        countries = Enum.GetValues(typeof(Countries))
         .Cast<Countries>()
         .Select(d => new SelectListItem { Text = d.ToDescription(), Value = d.ToString() }).ToList();

        if (Model.AddressType == AddressType.US)
        {
            var selected = countries.Where(x => x.Value == "UnitedStates").First();
            selected.Selected = true;
            Isdisabled = true;

            states = Enum.GetValues(typeof(USStates)).Cast<USStates>().Select(d => new SelectListItem { Text = d.ToDescription(), Value = d.ToString() }).ToList();
        }
        else if (Model.AddressType == AddressType.Canada)
        {
            var selected = countries.Where(x => x.Value == "Canada").First();
            selected.Selected = true;
            Isdisabled = true;

            states = Enum.GetValues(typeof(CanadaStates)).Cast<CanadaStates>().Select(d => new SelectListItem { Text = d.ToDescription(), Value = d.ToString() }).ToList();
        }
        else if (Model.AddressType == AddressType.INTERNATIONAL)
        {
            Isdisabled = false;
        }

    }
}
@Html.GenerateHiddenFields(Model)
@for (var i = 0; i < Model.Validations.Count; i++)
{
    var hiddnModelBindername = "Validations[" + i + "].QVModelType";
    @Html.Hidden(hiddnModelBindername, Model.Validations[i].GetType())

    @Html.HiddenFor(x => x.Validations[i].IsChecked)
    @Html.HiddenFor(x => x.Validations[i].Type)
    @Html.HiddenFor(x => x.Validations[i].Message)
}

@Html.HiddenFor(model => model.AddressType)
<div class="JbAddress" style="clear: both; overflow: hidden;">
    <div class="form-group JbFormControll address-line-1">
        @Html.LabelFor(model => model.AddressLine1, new { @class = (required ? "req" : ""), @data_value = "Address line 1" })
        @{
            textBoxHtmlAttr["class"] = "form-control";
            textBoxHtmlAttr["data-clientid"] = Model.ElementId + "AddressLine1";
            if (required)
            {
                textBoxHtmlAttr["data-val-Required"] = "Address line 1 is required";
            }
        }
        @if (!string.IsNullOrEmpty(Model.HelpText))
        {
            <a href="#" class="help" role="button" data-toggle="popover" data-trigger="focus" data-content="@Model.HelpText"></a>
        }
        @Html.TextBoxFor(model => model.AddressLine1, textBoxHtmlAttr)
        @Html.ValidationMessageFor(model => model.AddressLine1)
    </div>
    <div class="form-group JbFormControll address-line-2">
        @Html.LabelFor(model => model.AddressLine2, new { @class = " Custom-label", @data_value = "Address line 2" })
        @{
            var l2Attrs = textBoxHtmlAttr.ToArray().ToDictionary(c => c.Key, c => c.Value);
            l2Attrs["class"] = "form-control";
            l2Attrs["data-clientid"] = Model.ElementId + "AddressLine2";
            l2Attrs.Remove("data-val-Required");
            l2Attrs.Remove("data-val");
        }
        @Html.TextBoxFor(model => model.AddressLine2, l2Attrs)
        @Html.ValidationMessageFor(model => model.AddressLine2)
    </div>
    <div>
        <div class="form-group JbFormControll country element_width-half">
            @Html.LabelFor(model => model.Country, new { @class = (required ? "req" : ""), @data_value = "country" })
            @{
                dropDownHtmlAttrCountry["class"] = "form-control select-date";
                dropDownHtmlAttrCountry["data-clientid"] = Model.ElementId + "Country";
                dropDownHtmlAttrCountry["onchange"] = "FillStates(this)";
                if (required)
                {
                    dropDownHtmlAttrCountry["data-val-Required"] = "Country is required";
                }

            }
            @if (Model.AddressType == AddressType.INTERNATIONAL)
            {
                @Html.DropDownListFor(model => model.Country, countries, "", dropDownHtmlAttrCountry)
            }
            else
            {
                @Html.DropDownListFor(model => model.Country, countries,  new { @class = "form-control select-date", disabled = Isdisabled })
            }
            @Html.ValidationMessageFor(model => model.Country)
        </div>
        <div class="form-group JbFormControll city element_width-half">
            @Html.LabelFor(model => model.City, new { @class = (required ? "req" : ""), @data_value = "City" })
            @{
                textBoxHtmlAttr["class"] = "form-control";
                textBoxHtmlAttr["data-clientid"] = Model.ElementId + "City";
                if (required)
                {
                    textBoxHtmlAttr["data-val-Required"] = "City is required";
                }
            }
            @Html.TextBoxFor(model => model.City, textBoxHtmlAttr)
            @Html.ValidationMessageFor(model => model.City)
        </div>
        <div class="form-group JbFormControll state element_width-half">
            @Html.LabelFor(model => model.State, Model.AddressType == AddressType.US ? "State" : Model.AddressType == AddressType.Canada ? "Province" : "State/Province", new { @class = (required ? "req" : ""), @data_value = "State" })
            @{
                textBoxHtmlAttrState["class"] = "form-control";
                textBoxHtmlAttrState["data-clientid"] = Model.ElementId + "State";
                textBoxHtmlAttrState["data-txtState"] = "true";

                dropDownHtmlAttrState["class"] = "form-control";
                dropDownHtmlAttrState["data-clientid"] = Model.ElementId + "State";
                //dropDownHtmlAttrState["data-txtState"] = "true";
                if (required)
                {
                    textBoxHtmlAttrState["data-val-Required"] = "State is required";
                    dropDownHtmlAttrState["data-val-Required"] = "State is required";
                }
            }
            @if (Model.AddressType == AddressType.INTERNATIONAL)
            {
                @Html.TextBoxFor(model => model.State, textBoxHtmlAttrState)
                @Html.ValidationMessageFor(model => model.State)

                @Html.DropDownListFor(m => m.State, new SelectList(Enumerable.Empty<SelectListItem>(), "Value", "Text"),
                           "", new { @class = "form-control", @data_states="true", @style = "display:none" })
                @Html.ValidationMessageFor(model => model.State)
            }
            else
            {
                @Html.DropDownListFor(model => model.State, states,"", dropDownHtmlAttrState)
                @Html.ValidationMessageFor(model => model.State)
            }
        </div>
        <div class="form-group JbFormControll zip element_width-half">
            @Html.LabelFor(model => model.Zip, Model.AddressType == AddressType.US ? "ZIP" : Model.AddressType == AddressType.Canada ? "Postal code" : "ZIP/Postal code", new { @class = (required ? "req" : ""), @data_value = "ZIP" })
            @{
                textBoxHtmlAttr["class"] = "form-control JbZipCode";
                textBoxHtmlAttr["data-clientid"] = Model.ElementId + "Zip";
      
                if (required)
                {
                    textBoxHtmlAttr["data-val-Required"] = "Zip code is required";
                }
            }
            @Html.TextBoxFor(model => model.Zip, textBoxHtmlAttr)
            @Html.ValidationMessageFor(model => model.Zip)
        </div>
     
        


        
    </div>
</div>

@section scripts {


}